Module Memoria
    'Contiene:
    '-Classe Memoria: la classe memoria permite almacenar la informacion de cualquier tipo de memoria, independientemente
    'de su tamao, o del numero de bits de sus casillas.Por tanto contiene la informacion de la memoria, con todas la
    'variables para el control de esta. Tambien continene el atributo CadenaHex que no e mas que una part de Contenido 
    'en una cadena de texto, asi se puede mostrar en forma de texto com p.ej una Textbox, tambien va acompaado de los
    'atributos necesarios para controlar que este texto se muestre bien. Tambien incorpora todos los metodos necesarios
    'para manipular Contenido y CadenaTextoHex, e incluso incorpora un metodo que permita actualiza contenido a partir 
    'de un archivo .hex.

    '-Classe MemoriaAVR: esta classe consta de 2 objetos de la classe Memoria. Uno de ellos es Flash con el codigo de 
    'datos, y el otro es Eprom, con los datos. Ademas incorpora los metodos necesarios para programar, leer y verificar,
    'el contenido de los objetos Flash y Eprom en el microcontrolador.

    Public Class ClasseMemoria
        'Atributos correspondientes a la informacion de la estructura
        Public BitsDato As Integer 'Indica el numero de bits de cada posicion
        Public Contenido(,) As String 'Es la tabla con el contenido del archivo .HEX
        Public Filas As Integer 'Atributo con el numero total de filas que tiene la tabla
        Public Columnas As Integer 'Atributo con el numero de columnas que tiene la tabla
        'Atributos correspondientes a la represetnacion en la cadena de texto que es la que se muestra por las textbox.
        'Estos controlan la distribucion de la informacion del archivoHEX en CadenaTextoHEX que se mostrara por alguna textbox
        Public CadenaTextoHEX As String
        Dim ColumnasTextoHEX As Integer 'Numero de columnas que se pueden mostar en la textbox donde se mostrara la cadena, asi sabemos hasta donde imprimir
        Dim ColumnasDatosTextoHEX As Integer 'Numero de columnas en que se agrupan los datos, sin contar las direcciones  
        Public FilasTextoHEX As Integer 'Numero de filas que se pueden mostar en la textbox donde se mostrara la cadena, asi sabemos hasta donde imprimir


        'Procedimiento que inicializa los parametros asociados a CadenaTextoHex, la cual permite mostrar a traves de un textbox el contenido de
        'la memoria, pero antes hay que inicializar algunos parametros para que la informacion se vea bien.
        Public Sub ConfiguraCadenaTextoHEX(ByVal _ColumnasTextoHEX As Integer, ByVal _ColumnasDatosTextoHEX As Integer, ByVal _FilasTextoHEX As Integer)

            ColumnasTextoHEX = _ColumnasTextoHEX 'El "textbox" donde se mostrara la cadena esta dimensionado de forma que cabe este numero de columnas de caracteres
            ColumnasDatosTextoHEX = _ColumnasDatosTextoHEX 'En el "textbox" donde se mostrara la cadena se disponen 15 columnas de datos
            FilasTextoHEX = _FilasTextoHEX 'El "textbox" donde se mostrara la cadena esta dimensionado de forma que cabe este numero de filas

        End Sub


        'Procedimiento que rellena la CadenaTextoHEX (que se mostrara por la TextBox que toque) con el
        'Contenido. El parametro FilaOrigen indica a partir de que linea de la memoria queremos visualizar.
        'Para optimizar el proceso solo se actualiza el contenido del trozo de codigo visible, mientras
        'que la parte no visible no se carga, ya que no se ha de ver en la TextBox. Por tanto la parte 
        'del codigo que habra que mostrar es  desde la FilaOrigen hasta FilaOrigen + FilasCadenaHEX, 
        'donde FilasCadenaHEX es el ancho en filas de la TextBox donde se mostrara CadenaTextoHEX.
        Public Function RellenaCadenaTextoHEX(ByVal FilaOrigen As Integer) As String
            Dim i As Integer
            Dim j As Integer
            Dim FilaFinal As Integer
            Dim ColumnaFinal As Integer

            'Se calcula cual sera la ultima Fila que se pintara en la TextBox1
            FilaFinal = FilaOrigen + FilasTextoHEX
            'En el caso de que el calculo de la FilaFinal se mayor que el numero
            'de filas del archivo, se reajusta esta valor al maximo.
            If FilaFinal > Filas - 1 Then
                FilaFinal = Filas - 1
            End If

            CadenaTextoHEX = "" 'Se inicializa a "" el contenido de la TextBox1
            For i = FilaOrigen To FilaFinal 'Se van insertando filas, con saltos de carro, en la TextBox1
                'Insercion de la cabecera de la fila: ":direccion"
                CadenaTextoHEX = CadenaTextoHEX + ":" + NatAWordHex(i * Columnas) + " "
                'Se mostraran todas las columnas de la fila de ArchivoCargado tratada (ArchivoCargado.Filas) en la
                'textbox1 y si no caben todas la columnas, se imprimiran las que quepan (ColumnaDatosTexBox1-1)
                If ((Columnas) > (ColumnasDatosTextoHEX - 1)) Then
                    ColumnaFinal = ColumnasDatosTextoHEX - 1
                Else
                    ColumnaFinal = Columnas - 1
                End If
                'Comienzan a mostrarse las columnas de la fila tratada en la TextBox1
                For j = 0 To ColumnaFinal 'Se insertan tantos datos del objeto ArchivoHex como datos quepan en cada fila
                    CadenaTextoHEX = CadenaTextoHEX + " " + Contenido(i, j)
                Next j
                'Insercion del salto de carro para marcar final de linea
                CadenaTextoHEX = CadenaTextoHEX + Chr(13) + Chr(10)
            Next i

        End Function


        'Procedimiento para la actualizacion de Contenido. Se actualiza desde la direccion
        'origen hasta la direccion anterior a la destino con "FF" o "FFFF", y en la 
        'direccion de destino se situa el dato recibido. Si la direccion origen y la 
        'destino son la misma solo se actualizara la direcion destino con el dato, es 
        'decir que no hara falta colocar ninguna "FF" o "FFFF".
        Public Sub SituaHasta(ByVal direccion_origen As Integer, ByVal direccion_destino As Integer, ByVal dato As String)
            Dim i As Integer
            Dim j As Integer
            Dim k As Integer

            'Se comprueba que la direccion recibida sea valida, si no lo es no se ejecuta nada
            If (direccion_destino < Filas * Columnas) Then
                'Las posiciones que quedan entre la direccion origen y la que 
                'hay que escribir se llenan con 'FF'
                j = Fix(direccion_origen / Columnas)  'se obtiene la fila correspondiente al origen de la escritura
                k = direccion_origen Mod Columnas 'se obtiene la columna correspondiente al origen de la escritura
                For i = direccion_origen To direccion_destino - 1
                    'Al llegar al final de la fila se salta a la siguiente
                    If (k = Columnas) Then
                        j = j + 1
                        k = 0
                    End If
                    'Se coloca un dato vacio en la posicion no ocupada
                    Select Case BitsDato
                        Case 8
                            Contenido(j, k) = "FF"
                        Case 16
                            Contenido(j, k) = "FFFF"
                        Case Else
                            Contenido(j, k) = "FF"
                    End Select
                    k = k + 1
                Next i
                'Se guarda el dato en la posicion que toca
                j = Fix(direccion_destino / Columnas) 'se obtiene la fila correspondiente al origen de la escritura
                k = direccion_destino Mod Columnas 'se obtiene la columna correspondiente al origen de la escritura
                Contenido(j, k) = dato
            End If

        End Sub


        'Funcion que lee longitud bytes de un fichero y los retorna concatenados en forma de cadena
        'Retorna un False si hay algun tipo de error durante la lectura y un Ture si todo va bien.
        Public Function LeeBytesFichero(ByVal num_fichero As Integer, ByVal longitud As Integer, ByRef cadena As String) As Boolean
            Dim i As Integer
            Dim byte_leido As Byte

            'Se inicializan las variables
            LeeBytesFichero = True
            cadena = ""
            'Se comprueba que la longitud recibida sea valida
            If longitud >= 1 Then
                'Si la longitud es valida se ponen longitud caracteres en la cadena
                i = 0
                While (i < longitud) And Not EOF(num_fichero)
                    FileGet(num_fichero, byte_leido)
                    cadena = cadena + Chr(byte_leido)
                    i = i + 1
                End While
                'Si se ha salido del bucle porque se ha sobrepasado
                'el final del archivo se devuelve un errror
                If EOF(num_fichero) Then
                    LeeBytesFichero = False
                End If
            Else
                'Si la longitud no es valida se devuelve un mensaje de error
                LeeBytesFichero = False
            End If

        End Function


        'Funcion que actualiza Contenido con la informacion descrita en un archivo .HEX, ante se tiene que haber 
        'dimensionado adecuadamente Contenido, donde se guardara la informacion del archivo, con el tamao adecuado.
        'La funcion retornara un enetero que podra tomar los siguientes valores:
        '1-Todo Ok 
        '2-Error de checksum (a pesar de esto se inetenta abrir igual)
        '3-Error de formato ":"
        '4-Error de lectura indeterminado
        Public Function AbreHex(ByVal nombre_archivo As String) As Integer
            Dim fin_lectura As Boolean 'booleano para controlar la permanencia o salida en el bucle principal
            Dim reclen As Integer 'valor del campo RECLEN del registro leido
            Dim load_offset As Integer 'valor del campo LOAD_OFFSET del registro leido
            Dim rectyp As Integer 'valor del campo RECTYP del registro leido
            Dim checksum As Integer 'valr del campo checksum
            Dim checksum_acumulado As Integer 'variable donde se va acumulando la suma de los valores leidos
            Dim cadena_leida As String 'variable auxiliar para la lectura de los archivos            
            Dim valor As Integer 'valor a almacenar en memoria
            Dim ultima_direccion_escrita As Integer 'variable que indica qual es la ultima direccion en que se ha escrito
            Dim cadena_auxiliar As String
            Dim i As Integer

            On Error GoTo gestion_error

            'Antes de abrir el archivo Contenido debe estar correctamente inicializado y 
            'dimensionado para poder asi almacenar de forma adecuada los valores cargados.

            'Se abre el fichero con el nombre_indicado en modo de acceso aleatorio para lectura, el 
            'ultimo de todos los campos indica el numero de caracteres ledios en cada acceso.
            FileOpen(1, nombre_archivo, OpenMode.Random, OpenAccess.Read, OpenShare.Default, 1)
            'Inicializacion de las variables auxiliares
            ultima_direccion_escrita = 0
            fin_lectura = False
            AbreHex = 1
            While Not fin_lectura
                LeeBytesFichero(1, 1, cadena_leida)
                If cadena_leida <> ":" Then
                    fin_lectura = True
                    AbreHex = 3
                Else
                    checksum_acumulado = 0
                    'Lectura de RECLEN
                    LeeBytesFichero(1, 2, cadena_leida)
                    reclen = ByteHexANat(cadena_leida)
                    checksum_acumulado = checksum_acumulado + reclen 'Actualizacion el checksum acumulado
                    'Lectura de LOAD_OFFSET
                    LeeBytesFichero(1, 4, cadena_leida)
                    load_offset = WordHexANat(cadena_leida)
                    Select Case BitsDato
                        Case 8
                            'en el caso de que los datos de la memoria sean de 8 bits como los archivos .hex 
                            'utilizados trabajan con posiciones de 8 bits la direccion que estos dan es
                            'correcta y no hace falta dividirla por nada, es la direccio tal qual.
                            load_offset = load_offset
                        Case 16
                            'como los archivos .hex utilizados trabajan con posiciones de 8 bits, cada dos 
                            'posiciones del archivo son una posicion en la memoria, por eso la direccion
                            'leida del archivo hay que dividirla por 2
                            load_offset = Int(load_offset / 2)
                        Case Else
                    End Select
                    checksum_acumulado = checksum_acumulado + ByteHexANat(Mid(cadena_leida, 1, 2)) + ByteHexANat(Mid(cadena_leida, 3, 2)) 'Actualizacion el checksum acumulado
                    'Lectura de RECTYP
                    LeeBytesFichero(1, 2, cadena_leida)
                    rectyp = ByteHexANat(cadena_leida)
                    checksum_acumulado = checksum_acumulado + rectyp 'Actualizacion el checksum acumulado
                    'Lectura de los bytes DATA o INFO. Estos seran diferentes en funcion del tipo de registro
                    Select Case cadena_leida
                        Case "00" 'DATA REGISTER
                            'En funcion del numero de bits por data la lectura se hara de una u otra forma
                            Select Case BitsDato
                                Case 8
                                    'Lectura de cada uno los bytes de datos del registro de datos. Si los
                                    'datos son de 8 bits, se leen dos caracteres ASCII es decir 1 byte
                                    For i = 1 To reclen
                                        LeeBytesFichero(1, 2, cadena_leida)
                                        valor = ByteHexANat(cadena_leida) 'lectura del valor
                                        checksum_acumulado = checksum_acumulado + valor 'actualizacion el checksum acumulado
                                        SituaHasta(ultima_direccion_escrita, load_offset, NatAByteHex(valor))
                                        load_offset = load_offset + 1
                                        ultima_direccion_escrita = load_offset
                                    Next i
                                Case 16
                                    'Lectura de cada uno los bytes de datos del registro de datos. Si los
                                    'datos son de 16 bits, se leen cuatro caracteres ASCII es decir 2 bytes
                                    For i = 1 To reclen Step 2
                                        LeeBytesFichero(1, 4, cadena_leida)
                                        'Como en la cadena de 4 caracteres leida del archivo primero aparece el byte de la parte baja y luego el byte 
                                        'de la parte alta (bbaa), hay que invertirlos antes de colocarlos en su posicion en Contenido
                                        cadena_auxiliar = Mid(cadena_leida, 1, 2) 'se coge el byte de la parte alta
                                        cadena_leida = Mid(cadena_leida, 3, 2) + cadena_auxiliar 'se situa primero el byte de la parte alta y luego el de la parte baja
                                        valor = ByteHexANat(Mid(cadena_leida, 1, 2)) 'lectura del valor
                                        valor = valor + ByteHexANat(Mid(cadena_leida, 3, 4)) 'lectura del valor                                
                                        checksum_acumulado = checksum_acumulado + valor 'actualizacion el checksum acumulado
                                        SituaHasta(ultima_direccion_escrita, load_offset, cadena_leida)
                                        load_offset = load_offset + 1
                                        ultima_direccion_escrita = load_offset
                                    Next i
                                Case Else
                            End Select
                        Case "01" 'END OF FILE REGISTER
                            'Este tipo de registros no contienen campo DATA o INFO
                            'por tanto no hace falta leer nada                         
                            fin_lectura = True
                        Case Else
                            '02-REGISTRO DE DIRECCION EXTENDIDA DE SEGMENTO
                            '03-REGISTRO DE DIRECCION DE INICIO DE SEGMENTO
                            '04-REGISTRO DE DIRECCION LIENAL EXTENDIDA
                            '05-REGISTRO DE INICIO DE DIRECCION LINEAL
                            'Para los demas casos e leen de todos los siguientes RECLEN bytes del registro pero no se hace nada con ellos, solo se va guardando 
                            'el (checksum_acumulado) para hacer mas tarde la comprobacion del checksum, por lo demas, los datos leidos no se usan para nada mas.
                            For i = 1 To reclen
                                LeeBytesFichero(1, 2, cadena_leida)
                                valor = ByteHexANat(cadena_leida) 'lectura del valor
                                checksum_acumulado = checksum_acumulado + valor 'actualizacion el checksum acumulado
                            Next i
                    End Select
                    'Lectura del byte de CHECKSUM
                    LeeBytesFichero(1, 2, cadena_leida)
                    checksum = ByteHexANat(cadena_leida)
                    'El byte de checksum sumado a las suma de todos los bytes del registro ha
                    'de dar = 0 si da diferente de 0 es que se ha producido algun error. 
                    If NatAByteHex(checksum + checksum_acumulado) <> "00" Then
                        AbreHex = 2
                    End If
                    LeeBytesFichero(1, 2, cadena_leida)
                End If
            End While
            'Se cierra el fichero
            FileClose(1)
            Exit Function

gestion_error:
            'Si se produce un error de lectura se retorna el valor de 
            'error de lectura y se cierra el fichero.
            AbreHex = 4
            'Se cierra el fichero
            FileClose(1)

        End Function


        'Metodo constructor con parametros
        Public Sub New(ByVal _Filas As Integer, ByVal _Columnas As Integer, ByVal _BitsDato As Integer)
            Dim i As Integer
            Dim j As Integer

            'Inicializacion de los atributos Filas y Columnas
            Filas = _Filas
            Columnas = _Columnas
            BitsDato = _BitsDato
            'Se le asigna el tamao adecuado a la tabla
            ReDim Contenido(Filas - 1, Columnas - 1)
            'Inicializacion de la tabla posicion a posicion
            For i = 0 To Filas - 1
                For j = 0 To Columnas - 1
                    'Se coloca un dato "vacio" en cada posicion
                    Select Case BitsDato
                        Case 8
                            Contenido(i, j) = "FF"
                        Case 16
                            Contenido(i, j) = "FFFF"
                        Case Else
                            Contenido(i, j) = "FF"
                    End Select
                Next j
            Next i

        End Sub


        'Metodo destructor
        Public Sub Dispose()

            'Inicializacion de los atributos Filas y Columnas
            Filas = 0
            Columnas = 0
            BitsDato = 0
            'Se elimina todo el espacio asociado a la tabla
            ReDim Contenido(Filas, Columnas)

        End Sub

    End Class


    Public Class ClasseMemoriaAVR
        Public Flash As New ClasseMemoria(512, 8, 16)
        Public Eprom As New ClasseMemoria(64, 8, 8)


        'Funcion que programa el contenido de Flash en la memoria Flash del
        'microcontrolador AVR. Este usa el metodo mas eficiente que consiste en
        'modificar solo las direcciones cuyo contenido sea diferente de "FFFF", el 
        'resto supone que esta a "FFFF" y no hace falta sobreescribirlas. Este metodo 
        'es aconsejable usarlo siempre que antes se haya hecho un reset de la memoria 
        'de programa. Si la programacion va bien retorna un True, mientras que si hay 
        'algun error (solo se controla el error en la activacion) retorna False.
        Public Function ProgramacionRapidaFlash() As Boolean
            Dim echo As String = "00000000"
            Dim i As Integer
            Dim j As Integer
            Dim direccion As Integer 'variable que se va a actualizar

            ActivaProgramacionAVR()
            If Not ComandoProgrammingEnable(echo) Then
                'Si se produce un error al enviar el comando de programacion se retorna False
                ProgramacionRapidaFlash = False
            Else
                'Si no se produce ningun error al enviar el comando de programacion se programa el contenido de Flash en el microcontrolador
                direccion = 0 'se comienza por la direccion 00 que se
                'Se recorre cada una de las filas
                For i = 0 To Flash.Filas - 1
                    'Se recorre cada una de las columnas
                    For j = 0 To Flash.Columnas - 1
                        'Si el contenido de la direccion es "FFFF" no se escribe nada. Solo se considera el caso de "FFFF"
                        'porque esto es la prgramacion de un AVR y los AVR tienen palabras de codiogo de 16bits.
                        If Flash.Contenido(i, j) <> "FFFF" Then
                            ComandoWriteProgramMemoryBajo(NatAWordBin(direccion), ByteHexABin(Mid(Flash.Contenido(i, j), 3, 2)), echo)
                            ComandoWriteProgramMemoryAlto(NatAWordBin(direccion), ByteHexABin(Mid(Flash.Contenido(i, j), 1, 2)), echo)
                            'En el databook se indica que despues de escribir un dato en la memoria hay que esperear a que esta haya grabado el dato anterior
                            'Existen dos opciones: una es hacer polling sobre le microcontrolador antes de escribir la siguiente direccion a la espera que nos
                            'responda que esta listo, o la otra es esperar siempre una cantidad de tiempo fija (Twd_prog mirar tabla del datasheet)
                            Pausa(4) 'Twd_prog=4ms de pausa segun datasheet
                        End If
                        direccion = direccion + 1
                    Next j
                Next i
                ProgramacionRapidaFlash = True
            End If
            SetResetNotSelect()

        End Function


        'Funcion que programa el contenido del objeto Flash en la memoria Flash
        'del microcontrolador AVR. Este usa el metodo menos eficiente que consiste en
        'programar todas y cada una de las casillas de la memoria con el contenido. Si
        'la programacion va bien retorna un True, mientras que si hay algun error 
        '(solo se controla el error en la activacion) retorna False.
        Public Function ProgramacionCompletaFlash() As Boolean
            Dim echo As String = "00000000"
            Dim i As Integer
            Dim j As Integer
            Dim direccion As Integer 'variable que se va a actualizar

            ActivaProgramacionAVR()
            If Not ComandoProgrammingEnable(echo) Then
                'Si se produce un error al enviar el comando de programacion se retorna False
                ProgramacionCompletaFlash = False
            Else
                'Si no se produce ningun error al enviar el comando de programacion se programa el contendio de Flash en el microcontrolador
                direccion = 0 'se comienza por la direccion 00 que se
                'Se recorre cada una de las filas
                For i = 0 To Flash.Filas - 1
                    'Se recorre cada una de las columnas
                    For j = 0 To Flash.Columnas - 1
                        ComandoWriteProgramMemoryBajo(NatAWordBin(direccion), ByteHexABin(Mid(Flash.Contenido(i, j), 3, 2)), echo)
                        ComandoWriteProgramMemoryAlto(NatAWordBin(direccion), ByteHexABin(Mid(Flash.Contenido(i, j), 1, 2)), echo)
                        'En el databook se indica que despues de escribir un dato en la memoria hay que esperear a que esta haya grabado el dato anterior
                        'Existen dos opciones: una es hacer polling sobre le microcontrolador antes de escribir la siguiente direccion a la espera que nos
                        'responda que esta listo, o la otra es esperar siempre una cantidad de tiempo fija (Twd mirar tabla del datasheet)
                        Pausa(4) 'Twd_prog=4ms de pausa segun datasheet
                        direccion = direccion + 1
                    Next j
                Next i
                ProgramacionCompletaFlash = True
            End If
            SetResetNotSelect()

        End Function


        'Funcion que lee todo el contenido de la memoria de programa del microcontrolador
        'y lo carga en el Contendio de Flash. Si la programacion va bien retorna un True,
        'mientras que si hay algun error (solo se controla el error en la activacion)
        ' retorna False.
        Public Function LecturaCompletaFlash() As Boolean
            Dim echo As String = "00000000"
            Dim i As Integer
            Dim j As Integer
            Dim direccion As Integer 'variable que se va a actualizar
            Dim dato As String

            ActivaProgramacionAVR()
            If Not ComandoProgrammingEnable(echo) Then
                'Si se produce un error al enviar el comando de programacion se retorna False
                LecturaCompletaFlash = False
            Else
                'Si no se produce ningun error al enviar el comando de programacion se lee la Falsh 
                'del micrcocontrolador y se guarda en Contenido de Flash
                direccion = 0 'se comienza por la direccion 00 que se
                'Se recorre cada una de las filas
                For i = 0 To Flash.Filas - 1
                    'Se recorre cada una de las columnas
                    For j = 0 To Flash.Columnas - 1
                        dato = ComandoReadProgramMemoryBajo(NatAWordBin(direccion), echo)
                        dato = ComandoReadProgramMemoryAlto(NatAWordBin(direccion), echo) + dato
                        Flash.Contenido(i, j) = WordBinAHex(dato)
                        direccion = direccion + 1
                    Next j
                Next i
                LecturaCompletaFlash = True
            End If
            SetResetNotSelect()

        End Function


        'Funcion que verifica que el contenido de Flash coincide con el contenido 
        'memoria Flash del microcontrolador AVR. Este usa el de la metodo menos 
        'eficiente que consiste en verificar todas y cada una de las posiciones 
        'de la memoria independientemente del valor de esta. Si la verificacion va 
        'bien retorna un True, mientras que si encunetra un fallo sale del bucle 
        'y retorna un False, junto a la direccion del fallo por referencia. 
        Public Function VerificacionCompletaFlash(ByRef direccion_error As Integer) As Boolean
            Dim echo As String = "00000000"
            Dim i As Integer
            Dim j As Integer
            Dim direccion As Integer 'variable que se va a actualizar
            Dim dato As String

            ActivaProgramacionAVR()
            If Not ComandoProgrammingEnable(echo) Then
                'Si se produce un error al enviar el comando de programacion se retorna False
                VerificacionCompletaFlash = False
            Else
                'Si no se produce ningun error al enviar el comando de programacion se continua con la verificacion.
                direccion = 0 'se comienza por la direccion 00 que se
                direccion_error = 0
                VerificacionCompletaFlash = True
                i = 0
                j = 0
                'Se recorre cada una de las filas
                While (i <= (Flash.Filas - 1)) And (VerificacionCompletaFlash)
                    j = 0
                    'Se recorre cada una de las columnas
                    While (j <= (Flash.Columnas - 1)) And (VerificacionCompletaFlash)
                        dato = ComandoReadProgramMemoryBajo(NatAWordBin(direccion), echo)
                        dato = ComandoReadProgramMemoryAlto(NatAWordBin(direccion), echo) + dato
                        'Se comprueba si el dato leido y el contenido del archivo en esa direccion coinciden o no,
                        'de forma que si no coinciden se anota la direccion del error y se sale del bucle.
                        If Flash.Contenido(i, j) <> WordBinAHex(dato) Then
                            VerificacionCompletaFlash = False
                            direccion_error = direccion
                        End If
                        direccion = direccion + 1
                        j = j + 1
                    End While
                    i = i + 1
                End While
            End If
            SetResetNotSelect()

        End Function


        'Funcion que verifica que el contenido de Flash coincide con el contenido
        'de la memoria de Flash del microcontrolador AVR. Este usa el metodo mas
        'eficiente que consiste en verificar solo las direcciones cuyo contenido
        'sea diferente de "FFFF", el resto supone que esta a "FFFF" y no hace falta 
        'verificarlas. Si la verificacion va bien retorna un True, mientras que 
        'si encunetra un fallo sale del bucle y retorna un False, junto a la 
        'direccion del fallo por referencia. 
        Public Function VerificacionRapidaFlash(ByRef direccion_error As Integer) As Boolean
            Dim echo As String = "00000000"
            Dim i As Integer
            Dim j As Integer
            Dim direccion As Integer 'variable que se va a actualizar
            Dim dato As String

            ActivaProgramacionAVR()
            If Not ComandoProgrammingEnable(echo) Then
                'Si se produce un error al enviar el comando de programacion se retorna False
                VerificacionRapidaFlash = False
            Else
                'Si no se produce ningun error al enviar el comando de programacion se programa el HEX en el microcontrolador
                direccion = 0 'se comienza por la direccion 00 que se
                direccion_error = 0
                VerificacionRapidaFlash = True
                i = 0
                j = 0
                'Se recorre cada una de las filas
                While (i <= (Flash.Filas - 1)) And (VerificacionRapidaFlash)
                    j = 0
                    'Se recorre cada una de las columnas
                    While (j <= (Flash.Columnas - 1)) And (VerificacionRapidaFlash)
                        'Si el contenido de la direccion actual es diferente de "FFFF" entonces se verifica
                        If Flash.Contenido(i, j) <> "FFFF" Then
                            dato = ComandoReadProgramMemoryBajo(NatAWordBin(direccion), echo)
                            dato = ComandoReadProgramMemoryAlto(NatAWordBin(direccion), echo) + dato
                            'Se comprueba si el dato leido y el contenido del archivo en esa direccion coinciden o no,
                            'de forma que si no coinciden se anota la direccion del error y se sale del bucle.
                            If Flash.Contenido(i, j) <> WordBinAHex(dato) Then
                                VerificacionRapidaFlash = False
                                direccion_error = direccion
                            End If
                        End If
                        direccion = direccion + 1
                        j = j + 1
                    End While
                    i = i + 1
                End While
            End If
            SetResetNotSelect()

        End Function


        'Funcion que programa el contenido del objeto Eprom en la memoria Eprom
        'del microcontrolador AVR. Este usa el metodo menos eficiente que consiste en
        'programar todas y cada una de las casillas de la memoria con el contenido. Si
        'la programacion va bien retorna un True, mientras que si hay algun error 
        '(solo se controla el error en la activacion) retorna False.
        Public Function ProgramacionCompletaEprom() As Boolean
            Dim echo As String = "00000000"
            Dim i As Integer
            Dim j As Integer
            Dim direccion As Integer 'variable que se va a actualizar

            ActivaProgramacionAVR()
            If Not ComandoProgrammingEnable(echo) Then
                'Si se produce un error al enviar el comando de programacion se retorna False
                ProgramacionCompletaEprom = False
            Else
                'Si no se produce ningun error al enviar el comando de programacion se programa el Contenido de Eprom en el microcontrolador
                direccion = 0 'se comienza por la direccion 00 que se
                'Se recorre cada una de las filas
                For i = 0 To Eprom.Filas - 1
                    'Se recorre cada una de las columnas
                    For j = 0 To Eprom.Columnas - 1
                        ComandoWriteEpromMemory(NatAWordBin(direccion), ByteHexABin(Eprom.Contenido(i, j)), echo)
                        'En el databook se indica que despues de escribir un dato en la memoria hay que esperear a que esta haya grabado el dato anterior
                        'Existen dos opciones: una es hacer polling sobre le microcontrolador antes de escribir la siguiente direccion a la espera que nos
                        'responda que esta listo, o la otra es esperar siempre una cantidad de tiempo fija (Twd mirar tabla del datasheet)
                        Pausa(4)
                        direccion = direccion + 1
                    Next j
                Next i
                ProgramacionCompletaEprom = True
            End If
            SetResetNotSelect()

        End Function


        'Funcion que lee todo el contenido de la memoria Eprom del microcontrolador
        'y lo carga en la estructura de memoria. Si el proceso va bien retorna
        'un True, mientras que si hay algun error (solo se controla el error en la 
        'activacion) retorna False.
        Public Function LecturaCompletaEprom() As Boolean
            Dim echo As String = "00000000"
            Dim i As Integer
            Dim j As Integer
            Dim direccion As Integer 'variable que se va a actualizar
            Dim dato As String

            ActivaProgramacionAVR()
            If Not ComandoProgrammingEnable(echo) Then
                'Si se produce un error al enviar el comando de programacion se retorna False
                LecturaCompletaEprom = False
            Else
                'Si no se produce ningun error al enviar el comando de programacion se programa el HEX en el microcontrolador
                direccion = 0 'se comienza por la direccion 00 que se
                'Se recorre cada una de las filas
                For i = 0 To Eprom.Filas - 1
                    'Se recorre cada una de las columnas
                    For j = 0 To Eprom.Columnas - 1
                        dato = ComandoReadEpromMemory(NatAWordBin(direccion), echo)
                        Eprom.Contenido(i, j) = ByteBinAHex(dato)
                        direccion = direccion + 1
                    Next j
                Next i
                LecturaCompletaEprom = True
            End If
            SetResetNotSelect()

        End Function


        'Funcion que programa el contenido de Eprom en la memoria de Eprom
        'del microcontrolador AVR. Este usa el metodo mas eficiente que consiste en
        'modificar solo las direcciones cuyo contenido sea diferente de "FF", el 
        'resto supone que esta a "FF" y no hace falta sobreescribirlas. Este metodo 
        'es aconsejable usarlo siempre que antes se haya hecho un reset de la memoria 
        'de programa. Si la programacion va bien retorna un True, mientras que si hay 
        'algun error (solo se controla el error en la activacion) retorna False.
        Public Function ProgramacionRapidaEprom() As Boolean
            Dim echo As String = "00000000"
            Dim i As Integer
            Dim j As Integer
            Dim direccion As Integer 'variable que se va a actualizar

            ActivaProgramacionAVR()
            If Not ComandoProgrammingEnable(echo) Then
                'Si se produce un error al enviar el comando de programacion se retorna False
                ProgramacionRapidaEprom = False
            Else
                'Si no se produce ningun error al enviar el comando de programacion se programa Contenido de Eprom en el microcontrolador
                direccion = 0 'se comienza por la direccion 00 que se
                'Se recorre cada una de las filas
                For i = 0 To Eprom.Filas - 1
                    'Se recorre cada una de las columnas
                    For j = 0 To Eprom.Columnas - 1
                        'Si el contenido de la direccion es "FFFF" no se escribe nada. Solo se considera el caso de "FFFF"
                        'porque esto es la prgramacion de un AVR y los AVR tienen palabras de codiogo de 16bits.
                        If Eprom.Contenido(i, j) <> "FF" Then
                            ComandoWriteEpromMemory(NatAWordBin(direccion), ByteHexABin(Eprom.Contenido(i, j)), echo)
                            'En el databook se indica que despues de escribir un dato en la memoria hay que esperear a que esta haya grabado el dato anterior
                            'Existen dos opciones: una es hacer polling sobre le microcontrolador antes de escribir la siguiente direccion a la espera que nos
                            'responda que esta listo, o la otra es esperar siempre una cantidad de tiempo fija (Twd_prog mirar tabla del datasheet)
                            Pausa(4) 'Twd_prog=4ms de pausa segun datasheet
                        End If
                        direccion = direccion + 1
                    Next j
                Next i
                ProgramacionRapidaEprom = True
            End If
            SetResetNotSelect()

        End Function


        'Funcion que verifica que el contenido de Erpom coincide con el contenido 
        'de la Eprom del microcontrolador AVR. Este usa el metodo menos eficiente
        'que consiste en verificar todas y cada una de las posiciones de la memoria 
        'independientemente del valor de esta. Si la verificacion va bien retorna
        'un True, mientras que si encunetra un fallo sale del bucle y retorna un 
        'False, junto a la direccion del fallo la cual la pasa por referencia. 
        Public Function VerificacionCompletaEprom(ByRef direccion_error As Integer) As Boolean
            Dim echo As String = "00000000"
            Dim i As Integer
            Dim j As Integer
            Dim direccion As Integer 'variable que se va a actualizar
            Dim dato As String

            ActivaProgramacionAVR()
            If Not ComandoProgrammingEnable(echo) Then
                'Si se produce un error al enviar el comando de programacion se retorna False
                VerificacionCompletaEprom = False
            Else
                'Si no se produce ningun error al enviar el comando de programacion se verifica la Eprom del microcontrolador
                direccion = 0 'se comienza por la direccion 00 que se
                direccion_error = 0
                VerificacionCompletaEprom = True
                i = 0
                j = 0
                'Se recorre cada una de las filas
                While (i <= (Eprom.Filas - 1)) And (VerificacionCompletaEprom)
                    j = 0
                    'Se recorre cada una de las columnas
                    While (j <= (Eprom.Columnas - 1)) And (VerificacionCompletaEprom)
                        dato = ComandoReadEpromMemory(NatAWordBin(direccion), echo)
                        'Se comprueba si el dato leido y el contenido del archivo en esa direccion coinciden o no,
                        'de forma que si no coinciden se anota la direccion del error y se sale del bucle.
                        If Eprom.Contenido(i, j) <> ByteBinAHex(dato) Then
                            VerificacionCompletaEprom = False
                            direccion_error = direccion
                        End If
                        direccion = direccion + 1
                        j = j + 1
                    End While
                    i = i + 1
                End While
            End If
            SetResetNotSelect()

        End Function


        'Funcion que verifica que el contenido de Eprom coincide con el contenido
        'de la memoria Eprom del microcontrolador AVR. Este usa el metodo mas
        'eficiente que consiste en verificar solo las direcciones cuyo contenido
        'sea diferente de "FF", el resto supone que esta a "FF" y no hace falta 
        'verificarlas. Si la verificacion va bien retorna un True, mientras que 
        'si encunetra un fallo sale del bucle y retorna un False, junto a la 
        'direccion del fallo por referencia. 
        Public Function VerificacionRapidaEprom(ByRef direccion_error As Integer) As Boolean
            Dim echo As String = "00000000"
            Dim i As Integer
            Dim j As Integer
            Dim direccion As Integer 'variable que se va a actualizar
            Dim dato As String

            ActivaProgramacionAVR()
            If Not ComandoProgrammingEnable(echo) Then
                'Si se produce un error al enviar el comando de programacion se retorna False
                VerificacionRapidaEprom = False
            Else
                'Si no se produce ningun error al enviar el comando de programacion se verifica la Eprom
                direccion = 0 'se comienza por la direccion 00 que se
                direccion_error = 0
                VerificacionRapidaEprom = True
                i = 0
                j = 0
                'Se recorre cada una de las filas
                While (i <= (Eprom.Filas - 1)) And (VerificacionRapidaEprom)
                    j = 0
                    'Se recorre cada una de las columnas
                    While (j <= (Eprom.Columnas - 1)) And (VerificacionRapidaEprom)
                        'Si el contenido de la direccion actual es diferente de "FFFF" entonces se verifica
                        If Eprom.Contenido(i, j) <> "FF" Then
                            dato = ComandoReadEpromMemory(NatAWordBin(direccion), echo)
                            'Se comprueba si el dato leido y el contenido del archivo en esa direccion coinciden o no,
                            'de forma que si no coinciden se anota la direccion del error y se sale del bucle.
                            If Eprom.Contenido(i, j) <> ByteBinAHex(dato) Then
                                VerificacionRapidaEprom = False
                                direccion_error = direccion
                            End If
                            'En el databook se indica que despues de leer un dato en la memoria hay que esperear a que esta haya leido el dato anterior
                            'Existen dos opciones: una es hacer polling sobre el microcontrolador antes de leer la siguiente direccion a la espera que nos
                            'responda que esta listo, o la otra es esperar siempre una cantidad de tiempo fija (Twd mirar tabla del datasheet)
                            Pausa(5)
                        End If
                        direccion = direccion + 1
                        j = j + 1
                    End While
                    i = i + 1
                End While
            End If
            SetResetNotSelect()

        End Function


        'Metodo destructor
        Public Sub Dispose()

            'Se elimina la Flah
            Flash.Dispose()
            'Se elimina la Eprom
            Eprom.Dispose()

        End Sub


        Protected Overrides Sub Finalize()
            MyBase.Finalize()
        End Sub

    End Class



End Module
